// WaveVueView.h : interface of the CWaveVueView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVEVUEVIEW_H__3796280A_7689_45BC_B440_BC3EF56FB11F__INCLUDED_)
#define AFX_WAVEVUEVIEW_H__3796280A_7689_45BC_B440_BC3EF56FB11F__INCLUDED_

#include "ResizableFormView.h"
#include "PlotData.h"
#include "WPosCtrl.h"
#include "math.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CWaveVueView : public CResizableFormView
{
protected: // create from serialization only
	CWaveVueView();
	DECLARE_DYNCREATE(CWaveVueView)

public:
	//{{AFX_DATA(CWaveVueView)
	enum { IDD = IDD_WAVEVUE_FORM };
	CStatic	m_CursotTimeCtrl;
	CButton	m_SaveCtrl;
	CString	m_DestPathStr;
	CString	m_SrcPathStr;
	CString	m_FileStartTimeStr;
	CString	m_FileEndTimeStr;
	CString	m_FromTimeStr;
	CString	m_ToTimeStr;
	BOOL	m_UseAGC;
	CString	m_OffsetTxt;
	//}}AFX_DATA
	CWposCtrl m_WposCtrl;
// Attributes
public:
	CWaveVueDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWaveVueView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWaveVueView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void WavePosCallback( INT type, INT position);

// Generated message map functions
protected:
	//{{AFX_MSG(CWaveVueView)
	afx_msg void OnSrcbutton();
	afx_msg void OnSavebutton();
	afx_msg void OnQuitbutton();
	afx_msg void OnDeltaposFftspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestbutton();
	afx_msg void OnDestroy();
	afx_msg void OnAgccheck();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	double m_IQOffset;
	void DeDoppler(SHORT* pBuf);
	double m_IQAve;
	void InvalidateCursor( void );
	void UpdateToFrom();
	void DrawPlot();
	void StartFileRead(CString path);
	_int32 m_buf[FFTSIZE*2];
	Cxfft m_FFT;
	CString m_Str;
	CPlotData* m_pPlotData;
	double m_t;
	double m_tsec;
};

#ifndef _DEBUG  // debug version in WaveVueView.cpp
inline CWaveVueDoc* CWaveVueView::GetDocument()
   { return (CWaveVueDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WAVEVUEVIEW_H__3796280A_7689_45BC_B440_BC3EF56FB11F__INCLUDED_)
